Index: res/res_musiconhold.c
===================================================================
--- res/res_musiconhold.c	(revision 403615)
+++ res/res_musiconhold.c	(working copy)
@@ -292,8 +292,11 @@
 		chan->stream = NULL;
 	}
 
+	ao2_lock(state->class);
+
 	if (!state->class->total_files) {
 		ast_log(LOG_WARNING, "No files available for class '%s'\n", state->class->name);
+		ao2_unlock(state->class);
 		return -1;
 	}
 
@@ -333,6 +336,7 @@
 	}
 
 	if (tries == state->class->total_files) {
+		ao2_unlock(state->class);
 		return -1;
 	}
 
@@ -341,6 +345,8 @@
 
 	ast_debug(1, "%s Opened file %d '%s'\n", chan->name, state->pos, state->class->filearray[state->pos]);
 
+	ao2_unlock(state->class);
+
 	if (state->samples) {
 		size_t loc;
 		/* seek *SHOULD* be good since it's from a known location */
@@ -1435,7 +1441,7 @@
 						/* we found RT class with the same name, seems like we should continue playing existing one */
 						/* XXX This code is impossible to reach */
 						mohclass = mohclass_unref(mohclass, "unreffing potential mohclass (channel already has a class)");
-						mohclass = state->class;
+						mohclass = mohclass_ref(state->class, "adding ref to this channel's state->class");
 					}
 				}
 				/* We don't want moh_register to unref the mohclass because we do it at the end of this function as well.
@@ -1489,7 +1495,7 @@
 						if (state->class->realtime && !ast_test_flag(global_flags, MOH_CACHERTCLASSES) && !strcasecmp(mohclass->name, state->class->name)) {
 							/* we found RT class with the same name, seems like we should continue playing existing one */
 							mohclass = mohclass_unref(mohclass, "unreffing potential mohclass (channel already has one)");
-							mohclass = state->class;
+							mohclass = mohclass_ref(state->class, "adding ref to this channel's state->class");
 						}
 					} else {
 						if (ast_pthread_create_background(&mohclass->thread, NULL, monmp3thread, mohclass)) {
